//NRTSrame.cpp - Frame containing all the audio stuff

#include "wx\wxprec.h"

#ifndef WX_PRECOMP
#include "wx\wx.h"
#endif

#include "NRTSFrame.h"
//#include "lookupsine.hpp"

#include <wx/image.h>

#include "pa_common\pa_lib.c"
//#include "pa_common\portaudio.h"
#include "pa_common\pa_host.h"

#include "pa_win_wmme\pa_win_wmme.c"

//lookupsine osc1(44100.0f, 440.0f);
//lookupsine osc2(44100.0f, 440.0f);
//lookupsine osc3(44100.0f, 440.0f);
//lookupsine osc4(44100.0f, 440.0f);
//lookupsine mod(44100.0f, 5.0f);

BEGIN_EVENT_TABLE(wxPAFrame, wxFrame)	
	EVT_BUTTON(47, wxPAFrame::OnStartAudio)
	EVT_BUTTON(48, wxPAFrame::OnStopAudio)
	EVT_COMMAND_SCROLL(23, wxPAFrame::OnAmp1)
	EVT_COMMAND_SCROLL(25, wxPAFrame::OnAmp2)
	EVT_COMMAND_SCROLL(27, wxPAFrame::OnAmp3)
	EVT_COMMAND_SCROLL(29, wxPAFrame::OnAmp4)
	EVT_COMMAND_SCROLL(24, wxPAFrame::OnFreq1)
	EVT_COMMAND_SCROLL(26, wxPAFrame::OnFreq2)
	EVT_COMMAND_SCROLL(28, wxPAFrame::OnFreq3)
	EVT_COMMAND_SCROLL(30, wxPAFrame::OnFreq4)
	EVT_COMMAND_SCROLL(31, wxPAFrame::OnAM1)
	EVT_COMMAND_SCROLL(32, wxPAFrame::OnAM2)
	EVT_COMMAND_SCROLL(33, wxPAFrame::OnAM3)
	EVT_COMMAND_SCROLL(34, wxPAFrame::OnAM4)
	EVT_COMMAND_SCROLL(35, wxPAFrame::OnAMAmp1)
	EVT_COMMAND_SCROLL(36, wxPAFrame::OnAMAmp2)
	EVT_COMMAND_SCROLL(37, wxPAFrame::OnAMFreq1)
	EVT_COMMAND_SCROLL(38, wxPAFrame::OnAMFreq2)
	EVT_COMMAND_SCROLL(39, wxPAFrame::OnFM1)
	EVT_COMMAND_SCROLL(40, wxPAFrame::OnFM2)
	EVT_COMMAND_SCROLL(41, wxPAFrame::OnFM3)
	EVT_COMMAND_SCROLL(42, wxPAFrame::OnFM4)
	EVT_COMMAND_SCROLL(43, wxPAFrame::OnFMAmp1)
	EVT_COMMAND_SCROLL(44, wxPAFrame::OnFMAmp2)
	EVT_COMMAND_SCROLL(45, wxPAFrame::OnFMFreq1)
	EVT_COMMAND_SCROLL(46, wxPAFrame::OnFMFreq2)
	EVT_COMMAND_SCROLL(49, wxPAFrame::OnEnv1)
	EVT_COMMAND_SCROLL(50, wxPAFrame::OnEnv2)
	EVT_COMMAND_SCROLL(51, wxPAFrame::OnEnv3)
	EVT_COMMAND_SCROLL(52, wxPAFrame::OnEnv4)
	EVT_COMMAND_SCROLL(53, wxPAFrame::OnEnvTim1)
	EVT_COMMAND_SCROLL(54, wxPAFrame::OnEnvTim2)
	EVT_COMMAND_SCROLL(55, wxPAFrame::OnEnvTim3)
	EVT_COMMAND_SCROLL(56, wxPAFrame::OnEnvTim4)
	EVT_COMMAND_SCROLL(57, wxPAFrame::OnEnvTim5)
	EVT_COMMAND_SCROLL(58, wxPAFrame::OnEnvMLev)
END_EVENT_TABLE()

int patestCallback(void *inputBuffer, void *outputBuffer, unsigned long framesPerBuffer, PaTimestamp outTime, void *userData)
{
    unsigned int i;
	//Cast data passed through stream to our structure type.
    paTestData *data = (paTestData*)userData;
    float *out = (float*)outputBuffer;

	float temp_l, temp_r;
	float tempfreq;

	float temp_am1;
	float temp_am2;
	float temp_fm1;
	float temp_fm2;

	float temp_env = 0.0f;

	float temp2_1;
        
    for(i=0;i<framesPerBuffer;i++)
    {
		//Stereo channels are interleaved.
        /*out++ = (data->left_phase * 0.125f);              //left
        *out++ = (data->right_phase * 0.125f);             //right*/

		//modval = mod.getsample(5.0f);
		//modval += 1.0f;
		//modval *= 0.25f;
		//modval += 0.5f;

		temp_env = (float)data->env->getsample(data->envtim1,
										data->envtim2,
										data->envtim3,
										data->envtim4,
										data->envtim5,
										data->envmlev,
										true,
										true);

		temp_am2 = data->amosc2->getsample(data->amfreq2) * data->amamp2;

		temp_am2 *= 0.5f;
		temp_am2 += 0.5f;

		temp_am1 = data->amosc1->getsample(data->amfreq1) * (data->amamp1*temp_am2);

		temp_am1 *= 0.5f;
		temp_am1 += 0.5f;

		temp_fm2 = data->fmosc2->getsample(data->fmfreq2)/* * data->fmamp2*/;

		temp_fm2 += 1.0f;
		//temp_fm2 *= 0.5f;
		temp_fm2 += 0.001f;
		temp_fm2 *= data->fmfreq1;

		temp2_1 = data->fmfreq1+(temp_fm2*data->fmamp2);
		if(temp2_1 < 0.0f)
			temp2_1 = 10.0f;

		temp_fm1 = data->amosc1->getsample(temp2_1) * data->fmamp1;

		//temp_fm1 += 1.0f;
		//temp_fm1 *= 0.5f;
		//temp_fm1 += 0.001f;

		if(data->freq1 < 10.0f)
			temp_fm1 *= data->freq1;
		else if(data->freq2 < 10.0f)
			temp_fm1 *= data->freq2;
		else if(data->freq3 < 10.0f)
			temp_fm1 *= data->freq2;
		else if(data->freq2 < 10.0f)
			temp_fm1 *= data->freq3;
		else
			temp_fm1 *= 10.0f;

		if(data->freq1 > 1000.0f)
			tempfreq = 220.0f;
		else if(data->freq1 > 5.0f)
			tempfreq = data->freq1;
		else
			tempfreq = 880.0f;

		temp2_1 = tempfreq+(temp_fm1*data->fm1);
		if(temp2_1 < 0.0f)
			temp2_1 = 10.0f;

		temp_l = data->osc1->getsample(temp2_1) * (data->amp1*(1.0f-(temp_am1*data->am1))) * ((temp_env*data->env1)+(1.0f-data->env1));
		//temp_r = osc_r.getsample(tempfreq) * data->amp1;

		if(data->freq2 > 1000.0f)
			tempfreq = 220.0f;
		else if(data->freq2 > 5.0f)
			tempfreq = data->freq2;
		else
			tempfreq = 880.0f;

		temp2_1 = tempfreq+(temp_fm1*data->fm2);
		if(temp2_1 < 0.0f)
			temp2_1 = 10.0f;

		temp_l += data->osc2->getsample(temp2_1) * (data->amp2*(1.0f-(temp_am1*data->am2))) * ((temp_env*data->env2)+(1.0f-data->env2));

		if(data->freq3 > 1000.0f)
			tempfreq = 220.0f;
		else if(data->freq3 > 5.0f)
			tempfreq = data->freq3;
		else
			tempfreq = 880.0f;

		temp2_1 = tempfreq+(temp_fm1*data->fm3);
		if(temp2_1 < 0.0f)
			temp2_1 = 10.0f;

		temp_l += data->osc3->getsample(temp2_1) * (data->amp3*(1.0f-(temp_am1*data->am3))) * ((temp_env*data->env3)+(1.0f-data->env3));

		if(data->freq4 > 1000.0f)
			tempfreq = 220.0f;
		else if(data->freq4 > 5.0f)
			tempfreq = data->freq4;
		else
			tempfreq = 880.0f;

		temp2_1 = tempfreq+(temp_fm1*data->fm4);
		if(temp2_1 < 0.0f)
			temp2_1 = 10.0f;

		temp_l += data->osc4->getsample(temp2_1) * (data->amp4*(1.0f-(temp_am1*data->am4))) * ((temp_env*data->env4)+(1.0f-data->env4));

		*out++ = temp_l;
		*out++ = temp_l;
    }
    return 0;
}

wxPAFrame::wxPAFrame(const wxChar *title, int xpos, int ypos, int width, int height)
           : wxFrame((wxFrame *)NULL, -1, title, wxPoint(xpos, ypos), wxSize(width, height))
{
	PaError err;
	//const PaDeviceInfo *pdi;

	osc1 = 0;
	osc2 = 0;
	osc3 = 0;
	osc4 = 0;

	amosc1 = 0;
	amosc2 = 0;

	fmosc1 = 0;
	fmosc2 = 0;

	envelope = 0;

	SetBackgroundColour(wxColour(224, 224, 224));
	SetForegroundColour(wxColour(0, 0, 0));

	AudioIsOn = false;

	err = Pa_Initialize();
	if(err != paNoError)
	{
		UhOh = true;
		wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
		temp.ShowModal();
		return;
	}
	else
		UhOh = false;

	int NoDevicestemp = Pa_CountDevices();
	int NoDevices = 0;
	int j = -1;

	wxString *DeviceNames;

	//DeviceNames = new wxString[NoDevices];

	for(int i=0;i<NoDevicestemp;i++)
	{
		pdi = Pa_GetDeviceInfo(i);
		if(pdi->maxInputChannels == 0)
			NoDevices++;
	}

	DeviceNames = new wxString[NoDevices];

	for(i=0;i<NoDevicestemp;i++)
	{
		pdi = Pa_GetDeviceInfo(i);
		if(pdi->maxInputChannels == 0)
		{
			j++;
			DeviceNames[j] = wxString(pdi->name);
		}
	}

	Osc1Amp = new wxSlider(this, 23, 0 , 0, 100, wxPoint(10, 10), wxSize(100, 26));
	Osc2Amp = new wxSlider(this, 25, 0 , 0, 100, wxPoint(10, 50), wxSize(100, 26));
	Osc3Amp = new wxSlider(this, 27, 0 , 0, 100, wxPoint(10, 90), wxSize(100, 26));
	Osc4Amp = new wxSlider(this, 29, 0 , 0, 100, wxPoint(10, 130), wxSize(100, 26));

	Osc1Freq = new wxSlider(this, 24, 50 , 0, 100, wxPoint(120, 10), wxSize(100, 26));
	Osc2Freq = new wxSlider(this, 26, 50 , 0, 100, wxPoint(120, 50), wxSize(100, 26));
	Osc3Freq = new wxSlider(this, 28, 50 , 0, 100, wxPoint(120, 90), wxSize(100, 26));
	Osc4Freq = new wxSlider(this, 30, 50 , 0, 100, wxPoint(120, 130), wxSize(100, 26));

	Osc1AM = new wxSlider(this, 31, 0 , 0, 100, wxPoint(230, 10), wxSize(100, 26));
	Osc2AM = new wxSlider(this, 32, 0 , 0, 100, wxPoint(230, 50), wxSize(100, 26));
	Osc3AM = new wxSlider(this, 33, 0 , 0, 100, wxPoint(230, 90), wxSize(100, 26));
	Osc4AM = new wxSlider(this, 34, 0 , 0, 100, wxPoint(230, 130), wxSize(100, 26));

	amosc1Amp = new wxSlider(this, 35, 0 , 0, 100, wxPoint(10, 170), wxSize(100, 26));
	amosc2Amp = new wxSlider(this, 36, 0 , 0, 100, wxPoint(10, 210), wxSize(100, 26));

	amosc1Freq = new wxSlider(this, 37, 50 , 0, 100, wxPoint(120, 170), wxSize(100, 26));
	amosc2Freq = new wxSlider(this, 38, 50 , 0, 100, wxPoint(120, 210), wxSize(100, 26));

	Osc1FM = new wxSlider(this, 39, 0 , 0, 100, wxPoint(340, 10), wxSize(100, 26));
	Osc2FM = new wxSlider(this, 40, 0 , 0, 100, wxPoint(340, 50), wxSize(100, 26));
	Osc3FM = new wxSlider(this, 41, 0 , 0, 100, wxPoint(340, 90), wxSize(100, 26));
	Osc4FM = new wxSlider(this, 42, 0 , 0, 100, wxPoint(340, 130), wxSize(100, 26));

	fmosc1Amp = new wxSlider(this, 43, 0 , 0, 100, wxPoint(10, 250), wxSize(100, 26));
	fmosc2Amp = new wxSlider(this, 44, 0 , 0, 100, wxPoint(10, 290), wxSize(100, 26));

	fmosc1Freq = new wxSlider(this, 45, 50 , 0, 100, wxPoint(120, 250), wxSize(100, 26));
	fmosc2Freq = new wxSlider(this, 46, 50 , 0, 100, wxPoint(120, 290), wxSize(100, 26));

	Osc1Env = new wxSlider(this, 49, 0 , 0, 100, wxPoint(450, 10), wxSize(100, 26));
	Osc2Env = new wxSlider(this, 50, 0 , 0, 100, wxPoint(450, 50), wxSize(100, 26));
	Osc3Env = new wxSlider(this, 51, 0 , 0, 100, wxPoint(450, 90), wxSize(100, 26));
	Osc4Env = new wxSlider(this, 52, 0 , 0, 100, wxPoint(450, 130), wxSize(100, 26));
	
	EnvTime1 = new wxSlider(this, 53, 0 , 0, 100, wxPoint(230, 170), wxSize(100, 26));
	EnvTime2 = new wxSlider(this, 54, 0 , 0, 100, wxPoint(340, 170), wxSize(100, 26));
	EnvTime3 = new wxSlider(this, 55, 0 , 0, 100, wxPoint(450, 170), wxSize(100, 26));
	EnvTime4 = new wxSlider(this, 56, 0 , 0, 100, wxPoint(230, 210), wxSize(100, 26));
	EnvTime5 = new wxSlider(this, 57, 0 , 0, 100, wxPoint(340, 210), wxSize(100, 26));
	EnvMLev = new wxSlider(this, 58, 0 , 0, 100, wxPoint(450, 210), wxSize(100, 26));

	lOsc1Amp = new wxStaticText(this, -1, "Osc1 Amp", wxPoint(14, 36));
	lOsc2Amp = new wxStaticText(this, -1, "Osc2 Amp", wxPoint(14, 76));
	lOsc3Amp = new wxStaticText(this, -1, "Osc3 Amp", wxPoint(14, 116));
	lOsc4Amp = new wxStaticText(this, -1, "Osc4 Amp", wxPoint(14, 156));

	lOsc1Freq = new wxStaticText(this, -1, "Osc1 Freq", wxPoint(124, 36));
	lOsc2Freq = new wxStaticText(this, -1, "Osc2 Freq", wxPoint(124, 76));
	lOsc3Freq = new wxStaticText(this, -1, "Osc3 Freq", wxPoint(124, 116));
	lOsc4Freq = new wxStaticText(this, -1, "Osc4 Freq", wxPoint(124, 156));

	lOsc1AM = new wxStaticText(this, -1, "Osc1 AM", wxPoint(234, 36));
	lOsc2AM = new wxStaticText(this, -1, "Osc2 AM", wxPoint(234, 76));
	lOsc3AM = new wxStaticText(this, -1, "Osc3 AM", wxPoint(234, 116));
	lOsc4AM = new wxStaticText(this, -1, "Osc4 AM", wxPoint(234, 156));

	lamosc1Amp = new wxStaticText(this, -1, "AM Osc1 Amp", wxPoint(14, 196));
	lamosc2Amp = new wxStaticText(this, -1, "AM Osc2 Amp", wxPoint(14, 236));

	lamosc1Freq = new wxStaticText(this, -1, "AM Osc1 Freq", wxPoint(124, 196));
	lamosc2Freq = new wxStaticText(this, -1, "AM Osc2 Freq", wxPoint(124, 236));

	lOsc1FM = new wxStaticText(this, -1, "Osc1 FM", wxPoint(344, 36));
	lOsc2FM = new wxStaticText(this, -1, "Osc2 FM", wxPoint(344, 76));
	lOsc3FM = new wxStaticText(this, -1, "Osc3 FM", wxPoint(344, 116));
	lOsc4FM = new wxStaticText(this, -1, "Osc4 FM", wxPoint(344, 156));

	lfmosc1Amp = new wxStaticText(this, -1, "FM Osc1 Amp", wxPoint(14, 276));
	lfmosc2Amp = new wxStaticText(this, -1, "FM Osc2 Amp", wxPoint(14, 316));

	lfmosc1Freq = new wxStaticText(this, -1, "FM Osc1 Freq", wxPoint(124, 276));
	lfmosc2Freq = new wxStaticText(this, -1, "FM Osc2 Freq", wxPoint(124, 316));

	lOsc1Env = new wxStaticText(this, -1, "Osc1 Env", wxPoint(454, 36));
	lOsc2Env = new wxStaticText(this, -1, "Osc1 Env", wxPoint(454, 76));
	lOsc3Env = new wxStaticText(this, -1, "Osc1 Env", wxPoint(454, 116));
	lOsc4Env = new wxStaticText(this, -1, "Osc1 Env", wxPoint(454, 156));
	
	lEnvTime1 = new wxStaticText(this, -1, "Env Time1 (A)", wxPoint(234, 196));
	lEnvTime2 = new wxStaticText(this, -1, "Env Time2 (H)", wxPoint(344, 196));
	lEnvTime3 = new wxStaticText(this, -1, "Env Time3,4 (A,D)", wxPoint(454, 196));
	lEnvTime4 = new wxStaticText(this, -1, "Env Time5 (H)", wxPoint(234, 236));
	lEnvTime5 = new wxStaticText(this, -1, "Env Time6 (R)", wxPoint(344, 236));
	lEnvMLev = new wxStaticText(this, -1, "Env Mid Level", wxPoint(454, 236));

	Logo = new wxImage(wxString("Logo.bmp"), wxBITMAP_TYPE_BMP);
	LogoBmp = new wxBitmap(Logo);

	/*wxClientDC dc(this);
	dc.DrawBitmap(*LogoBmp, 340, 150, FALSE);*/

	//Test = new wxStaticText(this, -1, "Temp", wxPoint(120, 50));
	//Test->SetForegroundColour(wxColour(0,0,0));

	LogoScreen = new wxStaticBitmap(this, -1, *LogoBmp, wxPoint(450, 250));

	StartAudio = new wxButton(this, 47, wxString("Start Audio"), wxPoint(180, 338));
	StopAudio = new wxButton(this, 48, wxString("Stop Audio"), wxPoint(180, 367));

	SoundCards = new wxListBox(this, -1, wxPoint(275, 300), wxSize(-1, 90), NoDevices, DeviceNames, wxLB_SINGLE|wxSIMPLE_BORDER|wxLB_NEEDED_SB);

	data.amp1 = (float)Osc1Amp->GetValue()*0.01f;
	data.amp2 = (float)Osc2Amp->GetValue()*0.01f;
	data.amp3 = (float)Osc3Amp->GetValue()*0.01f;
	data.amp4 = (float)Osc4Amp->GetValue()*0.01f;

	data.freq1 = (float)Osc1Freq->GetValue()*1000.0f;
	data.freq2 = (float)Osc2Freq->GetValue()*1000.0f;
	data.freq3 = (float)Osc3Freq->GetValue()*1000.0f;
	data.freq4 = (float)Osc4Freq->GetValue()*1000.0f;

	data.am1 = (float)Osc1AM->GetValue()*0.01f;
	data.am2 = (float)Osc2AM->GetValue()*0.01f;
	data.am3 = (float)Osc3AM->GetValue()*0.01f;
	data.am4 = (float)Osc4AM->GetValue()*0.01f;

	data.fm1 = (float)Osc1FM->GetValue()*0.01f;
	data.fm2 = (float)Osc2FM->GetValue()*0.01f;
	data.fm3 = (float)Osc3FM->GetValue()*0.01f;
	data.fm4 = (float)Osc4FM->GetValue()*0.01f;

	data.amamp1 = (float)amosc1Amp->GetValue()*0.01f;
	data.amamp2 = (float)amosc2Amp->GetValue()*0.01f;

	data.amfreq1 = (float)amosc1Freq->GetValue()*0.1f;
	data.amfreq2 = (float)amosc2Freq->GetValue()*0.1f;

	data.fmamp1 = (float)fmosc1Amp->GetValue()*0.01f;
	data.fmamp2 = (float)fmosc2Amp->GetValue()*0.01f;

	data.fmfreq1 = (float)fmosc1Freq->GetValue()*0.1f;
	data.fmfreq2 = (float)fmosc2Freq->GetValue()*0.1f;

	data.env1 = (float)Osc1Env->GetValue()*0.01f;
	data.env2 = (float)Osc2Env->GetValue()*0.01f;
	data.env3 = (float)Osc3Env->GetValue()*0.01f;
	data.env4 = (float)Osc4Env->GetValue()*0.01f;
	
	data.envtim1 = (float)EnvTime1->GetValue()*0.01f;
	data.envtim2 = (float)EnvTime2->GetValue()*0.01f;
	data.envtim3 = (float)EnvTime3->GetValue()*0.01f;
	data.envtim4 = (float)EnvTime4->GetValue()*0.01f;
	data.envtim5 = (float)EnvTime5->GetValue()*0.01f;
	data.envmlev = (float)EnvMLev->GetValue()*0.01f;

	osc1 = new lookupsine(44100.0f, data.freq1);
	osc2 = new lookupsine(44100.0f, data.freq2);
	osc3 = new lookupsine(44100.0f, data.freq3);
	osc4 = new lookupsine(44100.0f, data.freq4);

	amosc1 = new lookupsine(44100.0f, data.amfreq1);
	amosc2 = new lookupsine(44100.0f, data.amfreq2);

	fmosc1 = new lookupsine(44100.0f, data.fmfreq1);
	fmosc2 = new lookupsine(44100.0f, data.fmfreq2);

	envelope = new sixparamenvelope(44100.0f);

	data.osc1 = this->osc1;
	data.osc2 = this->osc2;
	data.osc3 = this->osc3;
	data.osc4 = this->osc4;

	data.amosc1 = this->amosc1;
	data.amosc2 = this->amosc2;

	data.fmosc1 = this->fmosc1;
	data.fmosc2 = this->fmosc2;

	data.env = this->envelope;

	//wxMessageDialog temp1(this, "Ok to Initialise?", "Niall's Real Time Synth");
	//temp1.ShowModal();

	UhOh = false;
}

wxPAFrame::~wxPAFrame()
{
	PaError err;

	if(UhOh == false)
	{
		if(AudioIsOn)
		{
			//wxMessageDialog temp1(this, "Ok to stop stream?", "Niall's Real Time Synth");
			//temp1.ShowModal();
			err = Pa_StopStream(stream);
			if(err != paNoError)
			{
				wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
				temp.ShowModal();
			}

			//wxMessageDialog temp2(this, "Ok to close stream?", "Niall's Real Time Synth");
			//temp2.ShowModal();
			err = Pa_CloseStream(stream);
			if(err != paNoError)
			{
				wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
				temp.ShowModal();
			}

			//wxMessageDialog temp3(this, "Ok to terminate?", "Niall's Real Time Synth");
			//temp3.ShowModal();
			//Pa_Terminate();
		}
		Pa_Terminate();

		if(osc1)
			delete osc1;
		if(osc2)
			delete osc2;
		if(osc3)
			delete osc3;
		if(osc4)
			delete osc4;

		if(amosc1)
			delete amosc1;
		if(amosc2)
			delete amosc2;

		if(fmosc1)
			delete fmosc1;
		if(fmosc2)
			delete fmosc2;

		if(envelope)
			delete envelope;
	}
}

void wxPAFrame::OnStartAudio(wxCommandEvent &event)
{
	PaError err;

	if(!AudioIsOn)
	{
		//err = Pa_OpenDefaultStream(
		//&stream,        /* passes back stream pointer */
		//0,              /* no input channels */
		//2,              /* stereo output */
		//paFloat32,      /* 32 bit floating point output */
		//44100,          /* sample rate */
		//256,            /* frames per buffer */
		//0,              /* number of buffers, if zero then use default minimum */
		//patestCallback, /* specify our custom callback */
		//&data);         /* pass our data through to callback */

		err = Pa_OpenStream(&stream,					//stream pointer
							-1,							//desired soundcard (input)
							0,							//no. input channels
							paFloat32,					//input sampleformat
							NULL,						//inputDriverInfo
							SoundCards->GetSelection(),	//desired soundcard (output)
							2,							//stereo
							paFloat32,					//output sampleformat
							NULL,						//outputDriverInfo
							44100,						//samplerate
							256,						//framesperbuffer
							0,							//number of buffers (0 = default)
							paNoFlag,					//stream flags
							patestCallback,				//custom callback function
							&data);						//user data
		if(err != paNoError)
		{
			UhOh = true;
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
			return;
		}
		else
			UhOh = false;

		err = Pa_StartStream(stream);
		if(err != paNoError)
		{
			UhOh = true;
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
			return;
		}
		else
			UhOh = false;

		AudioIsOn = true;
	}
	else
	{
		wxMessageDialog temp(this, "Audio is already running, you incorrigible nincompoop!", "Niall's Real Time Synth");
		temp.ShowModal();
	}
}

void wxPAFrame::OnStopAudio(wxCommandEvent &event)
{
	PaError err;

	if(AudioIsOn)
	{
		err = Pa_StopStream(stream);
		if(err != paNoError)
		{
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
		}

		//wxMessageDialog temp2(this, "Ok to close stream?", "Niall's Real Time Synth");
		//temp2.ShowModal();
		err = Pa_CloseStream(stream);
		if(err != paNoError)
		{
			wxMessageDialog temp(this, Pa_GetErrorText(err), "PortAudio Error");
			temp.ShowModal();
		}

		AudioIsOn = false;
	}
	else
	{
		wxMessageDialog temp(this, "Audio is already stopped, you heathen philistine!", "Niall's Real Time Synth");
		temp.ShowModal();
	}
}

void wxPAFrame::OnAmp1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amp1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAmp2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amp2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAmp3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amp3 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAmp4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amp4 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFreq1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.freq1 = ((float)temp)*10.0f;

	//wxString s;
	//s.Printf("%f", data.freq1);

	//Test->SetLabel(s);
}

void wxPAFrame::OnFreq2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.freq2 = ((float)temp)*10.0f;
}

void wxPAFrame::OnFreq3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.freq3 = ((float)temp)*10.0f;
}

void wxPAFrame::OnFreq4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.freq4 = ((float)temp)*10.0f;
}

void wxPAFrame::OnAM1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.am1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAM2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.am2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAM3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.am3 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAM4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.am4 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFM1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fm1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFM2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fm2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFM3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fm3 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFM4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fm4 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAMAmp1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amamp1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAMAmp2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amamp2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnAMFreq1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amfreq1 = ((float)temp)*0.1f;
}

void wxPAFrame::OnAMFreq2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.amfreq2 = ((float)temp)*0.1f;
}

void wxPAFrame::OnFMAmp1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fmamp1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFMAmp2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fmamp2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnFMFreq1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fmfreq1 = ((float)temp)*0.1f;
}

void wxPAFrame::OnFMFreq2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.fmfreq2 = ((float)temp)*0.1f;
}

void wxPAFrame::OnEnv1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.env1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnv2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.env2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnv3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.env3 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnv4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.env4 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvTim1(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envtim1 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvTim2(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envtim2 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvTim3(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envtim3 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvTim4(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envtim4 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvTim5(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envtim5 = ((float)temp)*0.01f;
}

void wxPAFrame::OnEnvMLev(wxScrollEvent &event)
{
	int temp;

	temp = event.GetPosition();

	data.envmlev = ((float)temp)*0.01f;
}
