//NRTSFrame.h - Frame containing all the audio stuff

#ifndef _WXPAFRAME_H_
#define _WXPAFRAME_H_

//extern "C"
//{
	/*#include "pa_common\pa_lib.c"
	#include "pa_common\portaudio.h"
	#include "pa_common\pa_host.h"

	#include "pa_win_wmme\pa_win_wmme.c"*/
//}
#include "pa_common\portaudio.h"

#include "lookupsine.hpp"
#include "sixparamenvelope.hpp"

typedef struct
{
    //float left_phase;
    //float right_phase;

	lookupsine *osc1;
	lookupsine *osc2;
	lookupsine *osc3;
	lookupsine *osc4;

	lookupsine *amosc1;
	lookupsine *amosc2;

	lookupsine *fmosc1;
	lookupsine *fmosc2;

	sixparamenvelope *env;

	float amp1;
	float amp2;
	float amp3;
	float amp4;

	float freq1;
	float freq2;
	float freq3;
	float freq4;

	float am1;
	float am2;
	float am3;
	float am4;

	float fm1;
	float fm2;
	float fm3;
	float fm4;

	float env1;
	float env2;
	float env3;
	float env4;

	float amamp1;
	float amamp2;

	float amfreq1;
	float amfreq2;

	float fmamp1;
	float fmamp2;

	float fmfreq1;
	float fmfreq2;

	float envtim1;
	float envtim2;
	float envtim3;
	float envtim4;
	float envtim5;
	float envmlev;
}
paTestData;

class wxPAFrame : public wxFrame
{
  public:
	wxPAFrame(const wxChar *title, int xpos, int ypos, int width, int height);

	~wxPAFrame();
  private:
	PortAudioStream *stream;
	paTestData data;
	const PaDeviceInfo *pdi;

	bool UhOh;
	bool AudioIsOn;

	lookupsine *osc1;
	lookupsine *osc2;
	lookupsine *osc3;
	lookupsine *osc4;

	lookupsine *amosc1;
	lookupsine *amosc2;

	lookupsine *fmosc1;
	lookupsine *fmosc2;

	sixparamenvelope *envelope;

	//wxStaticText *Test;

	wxImage *Logo;
	wxBitmap *LogoBmp;

	wxStaticBitmap *LogoScreen;

	wxButton *StartAudio;
	wxButton *StopAudio;

	wxListBox *SoundCards;

	wxSlider *Osc1Amp;
	wxSlider *Osc2Amp;
	wxSlider *Osc3Amp;
	wxSlider *Osc4Amp;

	wxSlider *Osc1Freq;
	wxSlider *Osc2Freq;
	wxSlider *Osc3Freq;
	wxSlider *Osc4Freq;

	wxSlider *Osc1AM;
	wxSlider *Osc2AM;
	wxSlider *Osc3AM;
	wxSlider *Osc4AM;

	wxSlider *Osc1FM;
	wxSlider *Osc2FM;
	wxSlider *Osc3FM;
	wxSlider *Osc4FM;

	wxSlider *Osc1Env;
	wxSlider *Osc2Env;
	wxSlider *Osc3Env;
	wxSlider *Osc4Env;

	wxSlider *amosc1Amp;
	wxSlider *amosc2Amp;

	wxSlider *amosc1Freq;
	wxSlider *amosc2Freq;

	wxSlider *fmosc1Amp;
	wxSlider *fmosc2Amp;

	wxSlider *fmosc1Freq;
	wxSlider *fmosc2Freq;
	
	wxSlider *EnvTime1;
	wxSlider *EnvTime2;
	wxSlider *EnvTime3;
	wxSlider *EnvTime4;
	wxSlider *EnvTime5;
	wxSlider *EnvMLev;

	wxStaticText *lOsc1Amp;
	wxStaticText *lOsc2Amp;
	wxStaticText *lOsc3Amp;
	wxStaticText *lOsc4Amp;

	wxStaticText *lOsc1Freq;
	wxStaticText *lOsc2Freq;
	wxStaticText *lOsc3Freq;
	wxStaticText *lOsc4Freq;

	wxStaticText *lOsc1AM;
	wxStaticText *lOsc2AM;
	wxStaticText *lOsc3AM;
	wxStaticText *lOsc4AM;

	wxStaticText *lOsc1FM;
	wxStaticText *lOsc2FM;
	wxStaticText *lOsc3FM;
	wxStaticText *lOsc4FM;

	wxStaticText *lOsc1Env;
	wxStaticText *lOsc2Env;
	wxStaticText *lOsc3Env;
	wxStaticText *lOsc4Env;

	wxStaticText *lamosc1Amp;
	wxStaticText *lamosc2Amp;

	wxStaticText *lamosc1Freq;
	wxStaticText *lamosc2Freq;

	wxStaticText *lfmosc1Amp;
	wxStaticText *lfmosc2Amp;

	wxStaticText *lfmosc1Freq;
	wxStaticText *lfmosc2Freq;
	
	wxStaticText *lEnvTime1;
	wxStaticText *lEnvTime2;
	wxStaticText *lEnvTime3;
	wxStaticText *lEnvTime4;
	wxStaticText *lEnvTime5;
	wxStaticText *lEnvMLev;

  protected:
	virtual void OnStartAudio(wxCommandEvent &event);
	virtual void OnStopAudio(wxCommandEvent &event);

	virtual void OnAmp1(wxScrollEvent &event);
	virtual void OnAmp2(wxScrollEvent &event);
	virtual void OnAmp3(wxScrollEvent &event);
	virtual void OnAmp4(wxScrollEvent &event);

	virtual void OnFreq1(wxScrollEvent &event);
	virtual void OnFreq2(wxScrollEvent &event);
	virtual void OnFreq3(wxScrollEvent &event);
	virtual void OnFreq4(wxScrollEvent &event);

	virtual void OnAM1(wxScrollEvent &event);
	virtual void OnAM2(wxScrollEvent &event);
	virtual void OnAM3(wxScrollEvent &event);
	virtual void OnAM4(wxScrollEvent &event);

	virtual void OnFM1(wxScrollEvent &event);
	virtual void OnFM2(wxScrollEvent &event);
	virtual void OnFM3(wxScrollEvent &event);
	virtual void OnFM4(wxScrollEvent &event);

	virtual void OnEnv1(wxScrollEvent &event);
	virtual void OnEnv2(wxScrollEvent &event);
	virtual void OnEnv3(wxScrollEvent &event);
	virtual void OnEnv4(wxScrollEvent &event);

	virtual void OnAMAmp1(wxScrollEvent &event);
	virtual void OnAMAmp2(wxScrollEvent &event);

	virtual void OnAMFreq1(wxScrollEvent &event);
	virtual void OnAMFreq2(wxScrollEvent &event);

	virtual void OnFMAmp1(wxScrollEvent &event);
	virtual void OnFMAmp2(wxScrollEvent &event);

	virtual void OnFMFreq1(wxScrollEvent &event);
	virtual void OnFMFreq2(wxScrollEvent &event);

	virtual void OnEnvTim1(wxScrollEvent &event);
	virtual void OnEnvTim2(wxScrollEvent &event);
	virtual void OnEnvTim3(wxScrollEvent &event);
	virtual void OnEnvTim4(wxScrollEvent &event);
	virtual void OnEnvTim5(wxScrollEvent &event);
	virtual void OnEnvMLev(wxScrollEvent &event);

	DECLARE_EVENT_TABLE()
};

#endif