//RTFunc.cpp - Fast maths stuf for real-time use

#include <math.h>
#include "RTFunc.hpp"

float FastSinc(float Angle)
{
	float fASqr = Angle*Angle;
    float fResult = 7.61e-03f;
    fResult *= fASqr;
    fResult -= 1.6605e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    fResult *= Angle;
    return fResult;
}

float FastSinf(float Angle)
{
	float fASqr = Angle*Angle;
    float fResult = -2.39e-08f;
    fResult *= fASqr;
    fResult += 2.7526e-06f;
    fResult *= fASqr;
    fResult -= 1.98409e-04f;
    fResult *= fASqr;
    fResult += 8.3333315e-03f;
    fResult *= fASqr;
    fResult -= 1.666666664e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    fResult *= Angle;
    return fResult;
}

float FastInvSin(float val)
{
	float fRoot = (float)sqrt(1.0f-val);
    float fResult = -0.0187293f;
    fResult *= val;
    fResult += 0.0742610f;
    fResult *= val;
    fResult -= 0.2121144f;
    fResult *= val;
    fResult += 1.5707288f;
    fResult = (float)(0.5 * NDC_PI) - fRoot*fResult;
    return fResult;
}

float FastCosc(float Angle)
{
	float fASqr = Angle*Angle;
    float fResult = 3.705e-02f;
    fResult *= fASqr;
    fResult -= 4.967e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    return fResult;
}

float FastCosf(float Angle)
{
	float fASqr = Angle*Angle;
    float fResult = -2.605e-07f;
    fResult *= fASqr;
    fResult += 2.47609e-05f;
    fResult *= fASqr;
    fResult -= 1.3888397e-03f;
    fResult *= fASqr;
    fResult += 4.16666418e-02f;
    fResult *= fASqr;
    fResult -= 4.999999963e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    return fResult;
}

float FastInvCos(float val)
{
	float fRoot = (float)sqrt(1.0f-val);
    float fResult = -0.0187293f;
    fResult *= val;
    fResult += 0.0742610f;
    fResult *= val;
    fResult -= 0.2121144f;
    fResult *= val;
    fResult += 1.5707288f;
    fResult *= fRoot;
    return fResult;
}

double FastSinc(double Angle)
{
	double fASqr = Angle*Angle;
    double fResult = 7.61e-03f;
    fResult *= fASqr;
    fResult -= 1.6605e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    fResult *= Angle;
    return fResult;
}

double FastSinf(double Angle)
{
	double fASqr = Angle*Angle;
    double fResult = -2.39e-08f;
    fResult *= fASqr;
    fResult += 2.7526e-06f;
    fResult *= fASqr;
    fResult -= 1.98409e-04f;
    fResult *= fASqr;
    fResult += 8.3333315e-03f;
    fResult *= fASqr;
    fResult -= 1.666666664e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    fResult *= Angle;
    return fResult;
}

double FastInvSin(double val)
{
	double fRoot = (double)sqrt(1.0f-val);
    double fResult = -0.0187293f;
    fResult *= val;
    fResult += 0.0742610f;
    fResult *= val;
    fResult -= 0.2121144f;
    fResult *= val;
    fResult += 1.5707288f;
    fResult = (double)(0.5 * NDC_PI) - fRoot*fResult;
    return fResult;
}

double FastCosc(double Angle)
{
	double fASqr = Angle*Angle;
    double fResult = 3.705e-02f;
    fResult *= fASqr;
    fResult -= 4.967e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    return fResult;
}

double FastCosf(double Angle)
{
	double fASqr = Angle*Angle;
    double fResult = -2.605e-07f;
    fResult *= fASqr;
    fResult += 2.47609e-05f;
    fResult *= fASqr;
    fResult -= 1.3888397e-03f;
    fResult *= fASqr;
    fResult += 4.16666418e-02f;
    fResult *= fASqr;
    fResult -= 4.999999963e-01f;
    fResult *= fASqr;
    fResult += 1.0f;
    return fResult;
}

double FastInvCos(double val)
{
	double fRoot = (double)sqrt(1.0f-val);
    double fResult = -0.0187293f;
    fResult *= val;
    fResult += 0.0742610f;
    fResult *= val;
    fResult -= 0.2121144f;
    fResult *= val;
    fResult += 1.5707288f;
    fResult *= fRoot;
    return fResult;
}

float fastabs(float f) 
{
        int i=((*(int*)&f)&0x7fffffff);
        return (*(float*)&i);
}

//best to add this to the top of the file you're using it in (I got a load of unsresolved external symbols otherwise).
inline int float2int(float val)
{
	int result;
	_asm {
		fld dword ptr [val]
		fistp result
	}
	return result;
}