//rwbuffer.hpp - simple buffer object, w/multiple read & write methods (stores floats)

#ifndef _RWBUFFER_H_
#define _RWBUFFER_H_

//#include "RTFunc.hpp"
inline int float2int(float val)
{
	int result;
	_asm {
		fld dword ptr [val]
		fistp result
	}
	return result;
}

enum direction  //simple type to decribe the direction you're reading the buffer back
{
	dir_Backward,
	dir_Forward
};

class rwbuffer {
 protected:
  unsigned long size;
  float inindex, outindex;
  direction dir;
  bool loop, current;

  float *buf;

  virtual void checkfloat(float *index, bool io);//tests that the index isn't out of range, & corrects it if it is.
  virtual int checkindex(float *index, bool io); //tests that the index isn't out of range, & converts it to an integer

 public:
  rwbuffer() {}; //default constructor
  rwbuffer(unsigned long bufsize); //bufsize = no. of samples
  ~rwbuffer();

  virtual void writebuffer(float value);//increment set to 1(normal)
  virtual void writebuffer(float value, float increment);//user sets increment
  virtual void writebuffer(float *buffer);

  virtual float readbuffer();//increment set to 1, direction set to forward (normal)
  virtual float readbuffer(float increment);//direction set to forward (normal)
  virtual float readbuffer(direction fb);//increment set to 1 (normal)
  virtual float readbuffer(float increment, direction fb);//user sets direction
  virtual float readbuffer(float increment, float fb);//user sets direction (float) :
													  //>0.5 = forward
													  //<0.5 = backward
  virtual float readbuffer(float increment, float fb, float looping);

  virtual void resetoutindex();
  virtual void resetout2inindex();

  virtual void clearBuff();
};

#endif