//sixparamenvelope.hpp - Niall's daft 6-parameter envelope (AHDAHR)
//   _  _
//  / \/ \
// /      \

#ifndef _SIXPARAMENVELOPE_HPP_
#define _SIXPARAMENVELOPE_HPP_

class sixparamenvelope
{
  public:
	sixparamenvelope(float sr);
	~sixparamenvelope();

	virtual float getsample(float tim1,		//A
							float tim2,		//H
							float tim3,		//D,A
							float tim4,		//H
							float tim5,		//R
							float midLev,	// \/ Level
							bool OnOff,		//is the envelope on?
							bool Looping);	//is the envelope looping?

  protected:
	virtual float calcMult(float time, float start, float end);

	float samplerate;
	int currSection;
	float envelope;		//0->1
	float time[6];		//time (in seconds) of each section
	float mult1,		//calculated as the amount to multiply envelope by
		  mult3,
		  mult4,
		  mult6;
	float mLev;
	float currTime;		//where we are within the times above
	float timeIncrement;//1/samplerate, number of seconds to increment currTime by
};

#endif